Skip to main content

Classic environment v2

  • Reference

Documentation of the Dynatrace Environment API v2. Resources here generally supersede those in v1. Migration of resources from v1 is in progress.

If you miss a resource, consider using the Dynatrace Environment API v1.

To read about use cases and examples, see Dynatrace Documentation.

Notes about compatibility:

  • Operations marked as early adopter or preview may be changed in non-compatible ways, although we try to avoid this.
  • We may add new enum constants without incrementing the API version; thus, clients need to handle unknown enum constants gracefully.
Latest (V9)
npm install @dynatrace-sdk/client-classic-environment-v2

accessTokensActiveGateTokensClient​

import { accessTokensActiveGateTokensClient } from '@dynatrace-sdk/client-classic-environment-v2';

createToken​

accessTokensActiveGateTokensClient.createToken(config): Promise<ActiveGateTokenCreated>

Creates a new ActiveGate token

One of the following scopes is required:

  • environment-api:activegate-tokens:create
  • environment-api:activegate-tokens:write
  • fleet-management:activegate.tokens:create
  • fleet-management:activegate.tokens:write

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegate.tokens:write

The newly created token will be owned by the same user who owns the token used for authentication of the call.

Parameters​

NameType
config.body*requiredActiveGateTokenCreate

Returns​

Return typeStatus codeDescription
ActiveGateTokenCreated201Success. The token has been created. The body of the response contains the token secret.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { accessTokensActiveGateTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensActiveGateTokensClient.createToken({
    body: {
      activeGateType: "ENVIRONMENT",
      name: "myToken",
    },
  });

getToken​

accessTokensActiveGateTokensClient.getToken(config): Promise<ActiveGateToken>

Gets metadata of an ActiveGate token

One of the following scopes is required:

  • environment-api:activegate-tokens:read
  • fleet-management:activegate.tokens:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegate.tokens:read

The token secret is not exposed.

Parameters​

NameTypeDescription
config.activeGateTokenIdentifier*requiredstringThe ActiveGate token identifier, consisting of prefix and public part of the token.

Returns​

Return typeStatus codeDescription
ActiveGateToken200Success. The response contains the metadata of the tokens.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Failed. The requested resource doesn't exist. | Client side error. | Server side error.

Code example

import { accessTokensActiveGateTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensActiveGateTokensClient.getToken({
    activeGateTokenIdentifier: "...",
  });

listTokens​

accessTokensActiveGateTokensClient.listTokens(config): Promise<ActiveGateTokenList>

Lists all available ActiveGate tokens

One of the following scopes is required:

  • environment-api:activegate-tokens:read
  • fleet-management:activegate.tokens:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegate.tokens:read

You can limit the output by using pagination:

  1. Specify the number of results per page in the pageSize query parameter.
  2. Use the cursor from the nextPageKey field of the previous response in the nextPageKey query parameter to obtain subsequent pages.

Parameters​

NameTypeDescription
config.nextPageKeystring

The cursor for the next page of results. You can find it in the nextPageKey field of the previous response.

The first page is always returned if you don't specify the nextPageKey query parameter.

When the nextPageKey is set to obtain subsequent pages, you must omit all other query parameters.

config.pageSizenumber

The amount of ActiveGate tokens in a single response payload.

The maximal allowed page size is 3000 and the minimal size is 100.

If not set, 100 is used.

Returns​

Return typeStatus codeDescription
ActiveGateTokenList200Success. The response contains the list of ActiveGate tokens.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Failed. The requested resource doesn't exist. | Client side error. | Server side error.

Code example

import { accessTokensActiveGateTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensActiveGateTokensClient.listTokens();

revokeToken​

accessTokensActiveGateTokensClient.revokeToken(config): Promise<void>

Deletes an ActiveGate token

One of the following scopes is required:

  • environment-api:activegate-tokens:write
  • fleet-management:activegate.tokens:write

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegate.tokens:write

Parameters​

NameTypeDescription
config.activeGateTokenIdentifier*requiredstringThe ActiveGate token identifier, consisting of prefix and public part of the token to be deleted.

Returns​

Return typeStatus codeDescription
void204Success. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Failed. The requested resource doesn't exist. | Client side error. | Server side error.

Code example

import { accessTokensActiveGateTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensActiveGateTokensClient.revokeToken({
    activeGateTokenIdentifier: "...",
  });

accessTokensAgentTokensClient​

import { accessTokensAgentTokensClient } from '@dynatrace-sdk/client-classic-environment-v2';

getAgentConnectionToken​

accessTokensAgentTokensClient.getAgentConnectionToken(config): Promise<AgentConnectionToken>

Gets the agent connection token | maturity=EARLY_ADOPTER

One of the following scopes is required:

  • environment-api:agent-connection-tokens:read
  • fleet-management:oneagent.tokens:read

One of the following permissions is required:

  • environment:roles:agent-install
  • fleet-management:oneagent.tokens:read

Returns the agent connection token.

Returns​

Return typeStatus codeDescription
AgentConnectionToken200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Failed. The requested resource doesn't exist. | Client side error. | Server side error.

Code example

import { accessTokensAgentTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensAgentTokensClient.getAgentConnectionToken();

accessTokensApiTokensClient​

import { accessTokensApiTokensClient } from '@dynatrace-sdk/client-classic-environment-v2';

createApiToken​

⚠️ Deprecated

accessTokensApiTokensClient.createApiToken(config): Promise<ApiTokenCreated>

Creates a new API token

One of the following scopes is required:

  • environment-api:api-tokens:write
  • api-tokens:tokens:write

One of the following permissions is required:

  • environment:roles:viewer
  • api-tokens:tokens:write

The newly created token will be owned by the same user who owns the token used for authentication of the call.

Creating personal access tokens requires the environment:roles:viewer permission. Creating access tokens requires the environment:roles:manage-settings permission.

Parameters​

NameType
config.body*requiredApiTokenCreate

Returns​

Return typeStatus codeDescription
ApiTokenCreated201Success. The token has been created. The body of the response contains the token secret.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { accessTokensApiTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensApiTokensClient.createApiToken({
    body: { name: "tokenName", scopes: ["metrics.read"] },
  });

deleteApiToken​

⚠️ Deprecated

accessTokensApiTokensClient.deleteApiToken(config): Promise<void>

Deletes an API token

One of the following scopes is required:

  • environment-api:api-tokens:write
  • api-tokens:tokens:write

One of the following permissions is required:

  • environment:roles:viewer
  • api-tokens:tokens:write

Parameters​

NameTypeDescription
config.id*requiredstring

The ID of the token to be deleted.

You can specify either the ID or the secret of the token.

You can't delete the token you're using for authentication of the request.

Returns​

Return typeStatus codeDescription
void204Success. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. You can't delete the token you're using for authentication of the request. | Client side error. | Server side error.

Code example

import { accessTokensApiTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensApiTokensClient.deleteApiToken({
    id: "...",
  });

getApiToken​

⚠️ Deprecated

accessTokensApiTokensClient.getApiToken(config): Promise<ApiToken>

Gets API token metadata by token ID

One of the following scopes is required:

  • environment-api:api-tokens:read
  • api-tokens:tokens:read

One of the following permissions is required:

  • environment:roles:viewer
  • api-tokens:tokens:read

The token secret is not exposed.

Parameters​

NameType
config.id*requiredstring

Returns​

Return typeStatus codeDescription
ApiToken200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { accessTokensApiTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await accessTokensApiTokensClient.getApiToken({
  id: "...",
});

listApiTokens​

⚠️ Deprecated

accessTokensApiTokensClient.listApiTokens(config): Promise<ApiTokenList>

Lists all available API tokens

One of the following scopes is required:

  • environment-api:api-tokens:read
  • api-tokens:tokens:read

One of the following permissions is required:

  • environment:roles:viewer
  • api-tokens:tokens:read

You can limit the output by using pagination:

  1. Specify the number of results per page in the pageSize query parameter.
  2. Use the cursor from the nextPageKey field of the previous response in the nextPageKey query parameter to obtain subsequent pages.

Parameters​

NameTypeDescription
config.apiTokenSelectorstring

Filters the resulting sets of tokens. Only tokens matching the specified criteria are included into response.

You can set one or more of the following criteria:

  • Owner: owner("value"). The user that owns the token. Case-sensitive.
  • Personal access token: personalAccessToken(false). Set to true to include only personal access tokens or to false to include only API tokens.
  • Token scope: scope("scope1","scope2"). If several values are specified, the OR logic applies.

To set multiple criteria, separate them with commas (,). Only results matching all criteria are included into response.

config.fieldsstring

Specifies the fields to be included in the response.

The following fields are included by default:

  • id
  • name
  • enabled
  • owner
  • creationDate

To remove fields from the response, specify them with the minus (-) operator as a comma-separated list (for example, -creationDate,-owner).

You can include additional fields:

  • personalAccessToken

  • expirationDate

  • lastUsedDate

  • lastUsedIpAddress

  • modifiedDate

  • scopes

  • additionalMetadata

To add fields to the response, specify them with the plus (+) operator as a comma-separated list (for example, +expirationDate,+scopes). You can combine adding and removing of fields (for example, +scopes,-creationDate).

Alternatively, you can define the desired set of fields in the response. Specify the required fields as a comma-separated list, without operators (for example, creationDate,expirationDate,owner). The ID is always included in the response.

The fields string must be URL-encoded.

config.fromstring

Filters tokens based on the last usage time. The start of the requested timeframe.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years
config.nextPageKeystring

The cursor for the next page of results. You can find it in the nextPageKey field of the previous response.

The first page is always returned if you don't specify the nextPageKey query parameter.

When the nextPageKey is set to obtain subsequent pages, you must omit all other query parameters.

config.pageSizenumber

The amount of API tokens in a single response payload.

The maximal allowed page size is 10000 and the minimal allowed page size is 100.

If not set, 200 is used.

config.sortstring

The sort order of the token list.

You can sort by the following properties with a sign prefix for the sort order:

  • name: token name (+ a...z or - z...a)
  • lastUsedDate last used (+ never used tokens first - most recently used tokens first)
  • creationDate (+ oldest tokens first - newest tokens first)
  • expirationDate (+ tokens that expire soon first - unlimited tokens first)
  • modifiedDate last modified (+ never modified tokens first - most recently modified tokens first)

If no prefix is set, + is used.

If not set, tokens are sorted by creation date with newest first.



Default: -creationDate
config.tostring

Filters tokens based on the last usage time. The end of the requested timeframe.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the current timestamp is used.

Returns​

Return typeStatus codeDescription
ApiTokenList200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { accessTokensApiTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensApiTokensClient.listApiTokens();

lookupApiToken​

⚠️ Deprecated

accessTokensApiTokensClient.lookupApiToken(config): Promise<ApiToken>

Gets API token metadata by token secret

One of the following scopes is required:

  • environment-api:api-tokens:read
  • api-tokens:tokens:read

One of the following permissions is required:

  • environment:roles:viewer
  • api-tokens:tokens:read

Parameters​

NameType
config.body*requiredApiTokenSecret

Returns​

Return typeStatus codeDescription
ApiToken200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { accessTokensApiTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensApiTokensClient.lookupApiToken({
    body: {
      token:
        "dt0c01.ST2EY72KQINMH574WMNVI7YN.G3DFPBEJYMODIDAEX454M7YWBUVEFOWKPRVMWFASS64NFH52PX6BNDVFFM572RZM",
    },
  });

updateApiToken​

⚠️ Deprecated

accessTokensApiTokensClient.updateApiToken(config): Promise<void>

Updates an API token

One of the following scopes is required:

  • environment-api:api-tokens:write
  • api-tokens:tokens:write

One of the following permissions is required:

  • environment:roles:viewer
  • api-tokens:tokens:write

Parameters​

NameTypeDescription
config.body*requiredApiTokenUpdate
config.id*requiredstring

The ID of the token to be updated.

You can't disable the token you're using for authentication of the request.

Returns​

Return typeStatus codeDescription
void204Success. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { accessTokensApiTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensApiTokensClient.updateApiToken({
    id: "...",
    body: {},
  });

accessTokensTenantTokensClient​

import { accessTokensTenantTokensClient } from '@dynatrace-sdk/client-classic-environment-v2';

cancelRotation​

accessTokensTenantTokensClient.cancelRotation(config): Promise<TenantTokenConfig>

Cancels tenant token rotation

One of the following scopes is required:

  • environment-api:tenant-token-rotation:write
  • fleet-management:tenant-token:rotate

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:tenant-token:rotate

To learn how to rotate tokens, see Token rotation in Dynatrace Documentation.

Returns​

Return typeStatus codeDescription
TenantTokenConfig200Success. Rotation process has been cancelled. The current tenant token remains valid.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. There is no ongoing rotation process. | Client side error. | Server side error.

Code example

import { accessTokensTenantTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensTenantTokensClient.cancelRotation();

finishRotation​

accessTokensTenantTokensClient.finishRotation(config): Promise<TenantTokenConfig>

Finishes tenant token rotation

One of the following scopes is required:

  • environment-api:tenant-token-rotation:write
  • fleet-management:tenant-token:rotate

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:tenant-token:rotate

To learn how to rotate tokens, see Token rotation in Dynatrace Documentation.

Returns​

Return typeStatus codeDescription
TenantTokenConfig200Success. The rotation process is completed. The active field of the response contains the new tenant token.

Throws​

Error TypeError Message
ErrorEnvelopeErrorNo ongoing rotation process. | Client side error. | Server side error.

Code example

import { accessTokensTenantTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensTenantTokensClient.finishRotation();

getRotationStatus​

accessTokensTenantTokensClient.getRotationStatus(config): Promise<TenantTokenRotationStatus>

Gets tenant token rotation status

One of the following scopes is required:

  • environment-api:tenant-token-rotation:write
  • fleet-management:tenant-token:rotate

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:tenant-token:rotate

To learn how to rotate tokens, see Token rotation in Dynatrace Documentation.

Returns​

Return typeStatus codeDescription
TenantTokenRotationStatus200Success. Returns rotation status.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. Tenant token configuration is unavailable. | Client side error. | Server side error.

Code example

import { accessTokensTenantTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensTenantTokensClient.getRotationStatus();

startRotation​

accessTokensTenantTokensClient.startRotation(config): Promise<TenantTokenConfig>

Starts tenant token rotation

One of the following scopes is required:

  • environment-api:tenant-token-rotation:write
  • fleet-management:tenant-token:rotate

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:tenant-token:rotate

To learn how to rotate tokens, see Token rotation in Dynatrace Documentation.

Returns​

Return typeStatus codeDescription
TenantTokenConfig200Success. The new tenant token is created and will replace the old one. The active field of the response contains the new tenant token.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. Another rotation process is already in progress. | Client side error. | Server side error.

Code example

import { accessTokensTenantTokensClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await accessTokensTenantTokensClient.startRotation();

activeGatesActiveGateGroupsClient​

import { activeGatesActiveGateGroupsClient } from '@dynatrace-sdk/client-classic-environment-v2';

getActiveGateGroups​

⚠️ Deprecated

activeGatesActiveGateGroupsClient.getActiveGateGroups(config): Promise<ActiveGateGroups>

Lists ActiveGate groups

One of the following scopes is required:

  • environment-api:activegates:read
  • fleet-management:activegates:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:read

Deprecated since version 1.343. Use DQL Smartscape nodes to query ActiveGate data instead. See https://dt-url.net/mf03894

Returns​

Return typeStatus codeDescription
ActiveGateGroups200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { activeGatesActiveGateGroupsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesActiveGateGroupsClient.getActiveGateGroups();

activeGatesActiveGateTokensEnforcementClient​

import { activeGatesActiveGateTokensEnforcementClient } from '@dynatrace-sdk/client-classic-environment-v2';

getTokenEnforcement​

activeGatesActiveGateTokensEnforcementClient.getTokenEnforcement(config): Promise<ActiveGateTokenEnforcement>

Gets the status of ActiveGate tokens enforcement

Required scope: fleet-management:activegates:read One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:read

Returns​

Return typeStatus codeDescription
ActiveGateTokenEnforcement200Success. The response contains the status of ActiveGate tokens enforcement

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { activeGatesActiveGateTokensEnforcementClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesActiveGateTokensEnforcementClient.getTokenEnforcement();

activeGatesAutoUpdateConfigurationClient​

import { activeGatesAutoUpdateConfigurationClient } from '@dynatrace-sdk/client-classic-environment-v2';

getAutoUpdateConfigById​

⚠️ Deprecated

activeGatesAutoUpdateConfigurationClient.getAutoUpdateConfigById(config): Promise<ActiveGateAutoUpdateConfig>

Gets the configuration of auto-update for the specified ActiveGate

One of the following scopes is required:

  • environment-api:activegates:read
  • fleet-management:activegates:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:read

Gets the configuration of auto-update for the specified ActiveGate

Deprecation notice: This endpoint is deprecated. Use the Settings API endpoint GET /api/v2/settings/objects with schemaId builtin:deployment.activegate.updates and scopes=ENVIRONMENT_ACTIVE_GATE-{ActiveGate ID} to retrieve the auto-update setting of a specific ActiveGate.

Parameters​

NameTypeDescription
config.agId*requiredstringThe ID of the required ActiveGate.

Returns​

Return typeStatus codeDescription
ActiveGateAutoUpdateConfig200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorNot found. See response body for details. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateConfigurationClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateConfigurationClient.getAutoUpdateConfigById(
    { agId: "..." },
  );

getGlobalAutoUpdateConfigForTenant​

⚠️ Deprecated

activeGatesAutoUpdateConfigurationClient.getGlobalAutoUpdateConfigForTenant(config): Promise<ActiveGateGlobalAutoUpdateConfig>

Gets the global auto-update configuration of environment ActiveGates.

One of the following scopes is required:

  • environment-api:activegates:read
  • fleet-management:activegates:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:read

Gets the global auto-update configuration of environment ActiveGates.

Deprecation notice: This endpoint is deprecated. Use the Settings API endpoint GET /api/v2/settings/objects with schemaId builtin:deployment.activegate.updates and scopes=tenant to retrieve the global auto-update setting of environment ActiveGates.

Returns​

Return typeStatus codeDescription
ActiveGateGlobalAutoUpdateConfig200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { activeGatesAutoUpdateConfigurationClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateConfigurationClient.getGlobalAutoUpdateConfigForTenant();

putAutoUpdateConfigById​

⚠️ Deprecated

activeGatesAutoUpdateConfigurationClient.putAutoUpdateConfigById(config): Promise<void>

Updates the configuration of auto-update for the specified ActiveGate

One of the following scopes is required:

  • environment-api:activegates:write
  • fleet-management:activegates:write

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:write

Updates the configuration of auto-update for the specified ActiveGate

Deprecation notice: This endpoint is deprecated. Use the Settings API endpoint POST /api/v2/settings/objects with schemaId builtin:deployment.activegate.updates and scope=ENVIRONMENT_ACTIVE_GATE-{ActiveGate ID} to change the auto-update setting of a specific ActiveGate.

Parameters​

NameTypeDescription
config.agId*requiredstringThe ID of the required ActiveGate.
config.body*requiredActiveGateAutoUpdateConfig

Returns​

Return typeStatus codeDescription
void204Success. The auto-update configuration have been updated. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateConfigurationClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateConfigurationClient.putAutoUpdateConfigById(
    {
      agId: "...",
      body: {
        setting: "INHERITED",
        updateWindows: {
          windows: [
            {
              id: "vu9U3hXa3q0AAAABADdkeW5hdHJhY2Uuc2V0dGluZ3MuZGVwbG95bWVudC5tYW5h",
            },
          ],
        },
      },
    },
  );

putGlobalAutoUpdateConfigForTenant​

⚠️ Deprecated

activeGatesAutoUpdateConfigurationClient.putGlobalAutoUpdateConfigForTenant(config): Promise<void>

Puts the global auto-update configuration of environment ActiveGates.

One of the following scopes is required:

  • environment-api:activegates:write
  • fleet-management:activegates:write

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:write

Puts the global auto-update configuration of environment ActiveGates.

Deprecation notice: This endpoint is deprecated. Use the Settings API endpoint POST /api/v2/settings/objects with schemaId builtin:deployment.activegate.updates and scope=tenant to change the global auto-update setting of environment ActiveGates.

Parameters​

NameType
config.body*requiredActiveGateGlobalAutoUpdateConfig

Returns​

Return typeStatus codeDescription
void204Success. The global auto-update configuration have been updated. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateConfigurationClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateConfigurationClient.putGlobalAutoUpdateConfigForTenant(
    {
      body: {
        globalSetting: "ENABLED",
        updateWindows: {
          windows: [
            {
              id: "vu9U3hXa3q0AAAABADdkeW5hdHJhY2Uuc2V0dGluZ3MuZGVwbG95bWVudC5tYW5h",
            },
          ],
        },
      },
    },
  );

validateAutoUpdateConfigById​

⚠️ Deprecated

activeGatesAutoUpdateConfigurationClient.validateAutoUpdateConfigById(config): Promise<void>

Validates the payload for the POST /activeGates/{agId}/autoUpdate request.

One of the following scopes is required:

  • environment-api:activegates:write
  • fleet-management:activegates:write

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:write

Validates the payload for the POST /activeGates/{agId}/autoUpdate request.

Deprecation notice: This endpoint is deprecated. Use the Settings API endpoint POST /api/v2/settings/objects?validateOnly=true with schemaId builtin:deployment.activegate.updates and scope=ENVIRONMENT_ACTIVE_GATE-{ActiveGate ID} to validate the auto-update setting of a specific ActiveGate.

Parameters​

NameTypeDescription
config.agId*requiredstringThe ID of the required ActiveGate.
config.body*requiredActiveGateAutoUpdateConfig

Returns​

Return typeStatus codeDescription
void204Validated. The submitted auto-update configuration is valid. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateConfigurationClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateConfigurationClient.validateAutoUpdateConfigById(
    {
      agId: "...",
      body: {
        setting: "INHERITED",
        updateWindows: {
          windows: [
            {
              id: "vu9U3hXa3q0AAAABADdkeW5hdHJhY2Uuc2V0dGluZ3MuZGVwbG95bWVudC5tYW5h",
            },
          ],
        },
      },
    },
  );

validateGlobalAutoUpdateConfigForTenant​

⚠️ Deprecated

activeGatesAutoUpdateConfigurationClient.validateGlobalAutoUpdateConfigForTenant(config): Promise<void>

Validates the payload for the POST /activeGates/autoUpdate request.

One of the following scopes is required:

  • environment-api:activegates:write
  • fleet-management:activegates:write

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:write

Validates the payload for the POST /activeGates/autoUpdate request.

Deprecation notice: This endpoint is deprecated. Use the Settings API endpoint POST /api/v2/settings/objects?validateOnly=true with schemaId builtin:deployment.activegate.updates and scope=tenant to validate the global auto-update setting of environment ActiveGates.

Parameters​

NameType
config.body*requiredActiveGateGlobalAutoUpdateConfig

Returns​

Return typeStatus codeDescription
void204Validated. The submitted configuration is valid. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateConfigurationClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateConfigurationClient.validateGlobalAutoUpdateConfigForTenant(
    {
      body: {
        globalSetting: "ENABLED",
        updateWindows: {
          windows: [
            {
              id: "vu9U3hXa3q0AAAABADdkeW5hdHJhY2Uuc2V0dGluZ3MuZGVwbG95bWVudC5tYW5h",
            },
          ],
        },
      },
    },
  );

activeGatesAutoUpdateJobsClient​

import { activeGatesAutoUpdateJobsClient } from '@dynatrace-sdk/client-classic-environment-v2';

createUpdateJobForAg​

activeGatesAutoUpdateJobsClient.createUpdateJobForAg(config): Promise<UpdateJob>

Creates a new update job for the specified ActiveGate

One of the following scopes is required:

  • environment-api:activegates:write
  • fleet-management:activegates:write

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:write

Parameters​

NameTypeDescription
config.agId*requiredstringThe ID of the required ActiveGate.
config.body*requiredUpdateJob

Returns​

Return typeStatus codeDescription
UpdateJob201Success. The update-job have been created.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateJobsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateJobsClient.createUpdateJobForAg(
    {
      agId: "...",
      body: { targetVersion: "1.190.0.20200301-130000" },
    },
  );

deleteUpdateJobByJobIdForAg​

activeGatesAutoUpdateJobsClient.deleteUpdateJobByJobIdForAg(config): Promise<void>

Deletes the specified update job

One of the following scopes is required:

  • environment-api:activegates:write
  • fleet-management:activegates:write

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:write

Parameters​

NameTypeDescription
config.agId*requiredstringThe ID of the required ActiveGate.
config.jobId*requiredstringA unique identifier for a update-job of ActiveGate.

Returns​

Return typeStatus codeDescription
void204Success. The update-job have been deleted. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Not found. See response body for details. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateJobsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateJobsClient.deleteUpdateJobByJobIdForAg(
    { agId: "...", jobId: "..." },
  );

getAllUpdateJobList​

activeGatesAutoUpdateJobsClient.getAllUpdateJobList(config): Promise<UpdateJobsAll>

List ActiveGates with update jobs

One of the following scopes is required:

  • environment-api:activegates:read
  • fleet-management:activegates:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:read

The response includes ActiveGates that have both completed (successful and failed) jobs and jobs in progress.

Parameters​

NameTypeDescription
config.fromstring

The start of the requested timeframe for update jobs.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the relative timeframe of one day is used (now-1d).

Maximum timeframe is 31 days.

config.lastUpdatesbooleanIf true, filters the resulting set of update jobs to the most recent update of each type.

Default: false
config.startVersionstringFilters the resulting set of update-jobs by the initial version (required format <major>.<minor>.<revision>).
config.startVersionCompareType"EQUAL" | "GREATER" | "GREATER_EQUAL" | "LOWER" | "LOWER_EQUAL"

Filters the resulting set of update jobs by the specified initial version.

Specify the comparison operator here.

config.targetVersionstringFilters the resulting set of update-jobs by the target version (required format <major>.<minor>.<revision>).
config.targetVersionCompareType"EQUAL" | "GREATER" | "GREATER_EQUAL" | "LOWER" | "LOWER_EQUAL"

Filters the resulting set of update jobs by the specified target version.

Specify the comparison operator here.

config.tostring

The end of the requested timeframe for update jobs.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the current timestamp is used.

config.updateType"SYNTHETIC" | "ACTIVE_GATE" | "REMOTE_PLUGIN_AGENT" | "Z_REMOTE"Filters the resulting set of update-jobs by the update type.

Example: ACTIVE_GATE

Returns​

Return typeStatus codeDescription
UpdateJobsAll200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateJobsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateJobsClient.getAllUpdateJobList();

getUpdateJobByJobIdForAg​

activeGatesAutoUpdateJobsClient.getUpdateJobByJobIdForAg(config): Promise<UpdateJob>

Gets the parameters of the specified update job

One of the following scopes is required:

  • environment-api:activegates:read
  • fleet-management:activegates:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:read

Parameters​

NameTypeDescription
config.agId*requiredstringThe ID of the required ActiveGate.
config.jobId*requiredstringA unique identifier for a update-job of ActiveGate.

Returns​

Return typeStatus codeDescription
UpdateJob200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorNot found. See response body for details. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateJobsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateJobsClient.getUpdateJobByJobIdForAg(
    { agId: "...", jobId: "..." },
  );

getUpdateJobListByAgId​

activeGatesAutoUpdateJobsClient.getUpdateJobListByAgId(config): Promise<UpdateJobList>

Lists update jobs for the specified ActiveGate

One of the following scopes is required:

  • environment-api:activegates:read
  • fleet-management:activegates:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:read

The job can update the ActiveGate to the specified version or the latest available one.

Parameters​

NameTypeDescription
config.agId*requiredstringThe ID of the required ActiveGate.
config.fromstring

The start of the requested timeframe for update jobs.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the relative timeframe of one week is used (now-1w).

Maximum timeframe is 31 days.

config.lastUpdatesbooleanIf true, filters the resulting set of update jobs to the most recent update of each type.

Default: false
config.startVersionstringFilters the resulting set of update-jobs by the initial version (required format <major>.<minor>.<revision>).
config.startVersionCompareType"EQUAL" | "GREATER" | "GREATER_EQUAL" | "LOWER" | "LOWER_EQUAL"

Filters the resulting set of update jobs by the specified initial version.

Specify the comparison operator here.

config.targetVersionstringFilters the resulting set of update-jobs by the target version (required format <major>.<minor>.<revision>).
config.targetVersionCompareType"EQUAL" | "GREATER" | "GREATER_EQUAL" | "LOWER" | "LOWER_EQUAL"

Filters the resulting set of update jobs by the specified target version.

Specify the comparison operator here.

config.tostring

The end of the requested timeframe for update jobs.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the current timestamp is used.

config.updateType"SYNTHETIC" | "ACTIVE_GATE" | "REMOTE_PLUGIN_AGENT" | "Z_REMOTE"Filters the resulting set of update-jobs by the update type.

Example: ACTIVE_GATE

Returns​

Return typeStatus codeDescription
UpdateJobList200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorNot found. See response body for details. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateJobsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateJobsClient.getUpdateJobListByAgId(
    { agId: "..." },
  );

validateUpdateJobForAg​

activeGatesAutoUpdateJobsClient.validateUpdateJobForAg(config): Promise<void>

Validates the payload for the POST /activeGates/{agId}/updateJobs request.

One of the following scopes is required:

  • environment-api:activegates:write
  • fleet-management:activegates:write

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:write

Parameters​

NameTypeDescription
config.agId*requiredstringThe ID of the required ActiveGate.
config.body*requiredUpdateJob

Returns​

Return typeStatus codeDescription
void204Validated. The submitted update-job is valid. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { activeGatesAutoUpdateJobsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesAutoUpdateJobsClient.validateUpdateJobForAg(
    {
      agId: "...",
      body: { targetVersion: "1.190.0.20200301-130000" },
    },
  );

activeGatesClient​

import { activeGatesClient } from '@dynatrace-sdk/client-classic-environment-v2';

getAllActiveGates​

⚠️ Deprecated

activeGatesClient.getAllActiveGates(config): Promise<ActiveGateList>

Lists all available ActiveGates

One of the following scopes is required:

  • environment-api:activegates:read
  • fleet-management:activegates:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:read

The response includes all ActiveGates that are currently connected to the environment or have been connected during last 2 hours. Deprecated since version 1.343. Use DQL Smartscape nodes to query ActiveGate data instead. See https://dt-url.net/mf03894

Parameters​

NameTypeDescription
config.autoUpdate"ENABLED" | "DISABLED"Filters the resulting set of ActiveGates by the actual state of auto-update.
config.containerizedbooleanFilters the resulting set of ActiveGates to those which are running in container (true) or not (false).
config.disabledModuleArray<"SYNTHETIC" | "AWS" | "AZURE" | "BEACON_FORWARDER" | "CLOUD_FOUNDRY" | "DB_INSIGHT" | "DEBUGGING" | "EXTENSIONS_V1" | "EXTENSIONS_V2" | "KUBERNETES" | "LOGS" | "MEMORY_DUMPS" | "METRIC_API" | "ONE_AGENT_ROUTING" | "OTLP_INGEST" | "REST_API" | "VMWARE" | "Z_OS">Filters the resulting set of ActiveGates by the disabled modules.
config.enabledModuleArray<"SYNTHETIC" | "AWS" | "AZURE" | "BEACON_FORWARDER" | "CLOUD_FOUNDRY" | "DB_INSIGHT" | "DEBUGGING" | "EXTENSIONS_V1" | "EXTENSIONS_V2" | "KUBERNETES" | "LOGS" | "MEMORY_DUMPS" | "METRIC_API" | "ONE_AGENT_ROUTING" | "OTLP_INGEST" | "REST_API" | "VMWARE" | "Z_OS">Filters the resulting set of ActiveGates by the enabled modules.
config.fipsModebooleanFilters the resulting set of ActiveGates to those which are running in FIPS mode (true) or not (false).
config.groupstring

Filters the resulting set of ActiveGates by the group.

You can specify a partial name. In that case, the CONTAINS operator is used.

config.hostnamestring

Filters the resulting set of ActiveGates by the name of the host it's running on.

You can specify a partial name. In that case, the CONTAINS operator is used.

config.loadBalancerAddressstring

Filters the resulting set of ActiveGates by the Load Balancer address.

You can specify a partial address. In that case, the CONTAINS operator is used.

config.networkAddressstring

Filters the resulting set of ActiveGates by the network address.

You can specify a partial address. In that case, the CONTAINS operator is used.

config.networkZonestring

Filters the resulting set of ActiveGates by the network zone.

You can specify a partial name. In that case, the CONTAINS operator is used.

config.onlinebooleanFilters the resulting set of ActiveGates by the communication status.
config.osArchitecture"S390" | "X86" | "ARM" | "PPCLE"Filters the resulting set of ActiveGates by the OS architecture of the host it's running on.
config.osType"LINUX" | "WINDOWS"Filters the resulting set of ActiveGates by the OS type of the host it's running on.
config.tokenExpirationSetbooleanFilters the resulting set of ActiveGates to those with set expiration date for authorization token.
config.tokenState"UNKNOWN" | "ABSENT" | "EXPIRING" | "INVALID" | "UNSUPPORTED" | "VALID"Filters the resulting set of ActiveGates to those with authorization token in specified state.
config.type"ENVIRONMENT" | "ENVIRONMENT_MULTI"Filters the resulting set of ActiveGates by the ActiveGate type.
config.updateStatus"UNKNOWN" | "INCOMPATIBLE" | "OUTDATED" | "SCHEDULED" | "SUPPRESSED" | "UP2DATE" | "UPDATE_IN_PROGRESS" | "UPDATE_PENDING" | "UPDATE_PROBLEM"Filters the resulting set of ActiveGates by the auto-update status.
config.versionstring

Filters the resulting set of ActiveGates by the specified version.

Specify the version in <major>.<minor>.<revision> format (for example, 1.195.0) here.

config.versionCompareType"EQUAL" | "GREATER" | "GREATER_EQUAL" | "LOWER" | "LOWER_EQUAL"

Filters the resulting set of ActiveGates by the specified version.

Specify the comparison operator here.

Returns​

Return typeStatus codeDescription
ActiveGateList200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { activeGatesClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await activeGatesClient.getAllActiveGates();

getOneActiveGateById​

⚠️ Deprecated

activeGatesClient.getOneActiveGateById(config): Promise<ActiveGate>

Gets the details of the specified ActiveGate

One of the following scopes is required:

  • environment-api:activegates:read
  • fleet-management:activegates:read

One of the following permissions is required:

  • environment:roles:manage-settings
  • fleet-management:activegates:read

Deprecated since version 1.343. Use DQL Smartscape nodes to query ActiveGate data instead. See https://dt-url.net/mf03894

Parameters​

NameTypeDescription
config.agId*requiredstringThe ID of the required ActiveGate.

Returns​

Return typeStatus codeDescription
ActiveGate200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorNot found. See response body for details. | Client side error. | Server side error.

Code example

import { activeGatesClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await activeGatesClient.getOneActiveGateById({
  agId: "...",
});

activeGatesRemoteConfigurationManagementClient​

import { activeGatesRemoteConfigurationManagementClient } from '@dynatrace-sdk/client-classic-environment-v2';

createRemoteIdentityOperationJob​

activeGatesRemoteConfigurationManagementClient.createRemoteIdentityOperationJob(config): Promise<RemoteConfigurationManagementJob>

Creates a new remote configuration management job

Required scope: fleet-management:activegates:write One of the following permissions is required:

  • environment:roles:viewer
  • fleet-management:activegates:write

Parameters​

Returns​

Return typeStatus codeDescription
RemoteConfigurationManagementJob201Created

Throws​

Error TypeError Message
RemoteConfigurationManagementValidationResultErrorFailed. The input is invalid.
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { activeGatesRemoteConfigurationManagementClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesRemoteConfigurationManagementClient.createRemoteIdentityOperationJob(
    {
      body: {
        entities: ["0x2b7c0b02,0x4928065d"],
        operations: [
          { attribute: "networkZone", operation: "set" },
        ],
      },
    },
  );

createRemoteIdentityOperationPreview​

activeGatesRemoteConfigurationManagementClient.createRemoteIdentityOperationPreview(config): Promise<RemoteConfigurationManagementPreviewList>

Creates a preview for remote configuration management job - applicable only to network zone and ActiveGate group

Required scope: fleet-management:activegates:write One of the following permissions is required:

  • environment:roles:viewer
  • fleet-management:activegates:write

Parameters​

Returns​

Return typeStatus codeDescription
RemoteConfigurationManagementPreviewList200Success

Throws​

Error TypeError Message
RemoteConfigurationManagementValidationResultErrorFailed. The input is invalid.
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { activeGatesRemoteConfigurationManagementClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesRemoteConfigurationManagementClient.createRemoteIdentityOperationPreview(
    {
      body: {
        entities: ["0x2b7c0b02,0x4928065d"],
        operations: [
          { attribute: "networkZone", operation: "set" },
        ],
      },
    },
  );

getCurrentRemoteIdentityOperationJob​

activeGatesRemoteConfigurationManagementClient.getCurrentRemoteIdentityOperationJob(config): Promise<void | RemoteConfigurationManagementJob>

Gets remote configuration management job that is currently running

Required scope: fleet-management:activegates:read One of the following permissions is required:

  • environment:roles:viewer
  • fleet-management:activegates:read

The currently running remote configuration management job may be related to ActiveGates or OneAgents. There is a limit of one concurrent remote configuration management job, regardless of the entity type.

Returns​

Return typeStatus codeDescription
RemoteConfigurationManagementJob200Success
void204No remote configuration management job is currently running

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { activeGatesRemoteConfigurationManagementClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesRemoteConfigurationManagementClient.getCurrentRemoteIdentityOperationJob();

getRemoteIdentityOperationJob​

activeGatesRemoteConfigurationManagementClient.getRemoteIdentityOperationJob(config): Promise<RemoteConfigurationManagementJob>

Gets the specified remote configuration management job

Required scope: fleet-management:activegates:read One of the following permissions is required:

  • environment:roles:viewer
  • fleet-management:activegates:read

Parameters​

NameTypeDescription
config.id*requiredstringThe ID of the required remote configuration management job.

Returns​

Return typeStatus codeDescription
RemoteConfigurationManagementJob200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The requested resource doesn't exist. | Client side error. | Server side error.

Code example

import { activeGatesRemoteConfigurationManagementClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesRemoteConfigurationManagementClient.getRemoteIdentityOperationJob(
    { id: "..." },
  );

getRemoteIdentityOperations​

activeGatesRemoteConfigurationManagementClient.getRemoteIdentityOperations(config): Promise<RemoteConfigurationManagementJobList>

Lists finished ActiveGate remote configuration management jobs

Required scope: fleet-management:activegates:read One of the following permissions is required:

  • environment:roles:viewer
  • fleet-management:activegates:read

The response includes finished jobs for the last 7 days.

Parameters​

NameTypeDescription
config.fromstring

The start of the requested timeframe for a remote configuration management job.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years
config.tostring

The end of the requested timeframe for a remote configuration management job.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the current timestamp is used.

Returns​

Return typeStatus codeDescription
RemoteConfigurationManagementJobList200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { activeGatesRemoteConfigurationManagementClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesRemoteConfigurationManagementClient.getRemoteIdentityOperations();

validateRemoteIdentityOperation​

activeGatesRemoteConfigurationManagementClient.validateRemoteIdentityOperation(config): Promise<void>

Validates the payload for the POST /activeGates/remoteConfigurationManagement request.

Required scope: fleet-management:activegates:write One of the following permissions is required:

  • environment:roles:viewer
  • fleet-management:activegates:write

Parameters​

Returns​

Return typeStatus codeDescription
void204Success. Response doesn't have a body.

Throws​

Error TypeError Message
RemoteConfigurationManagementValidationResultErrorFailed. The input is invalid.
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { activeGatesRemoteConfigurationManagementClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await activeGatesRemoteConfigurationManagementClient.validateRemoteIdentityOperation(
    {
      body: {
        entities: ["0x2b7c0b02,0x4928065d"],
        operations: [
          { attribute: "networkZone", operation: "set" },
        ],
      },
    },
  );

adaptiveTrafficManagementClient​

import { adaptiveTrafficManagementClient } from '@dynatrace-sdk/client-classic-environment-v2';

getRootSpansPerMinute​

adaptiveTrafficManagementClient.getRootSpansPerMinute(config): Promise<AdaptiveTrafficManagementDto>

Gets sampling configuration.

Required scope: adaptive-traffic-management:sampling-configuration:read

Returns​

Return typeStatus codeDescription
AdaptiveTrafficManagementDto200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { adaptiveTrafficManagementClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await adaptiveTrafficManagementClient.getRootSpansPerMinute();

attacksClient​

import { attacksClient } from '@dynatrace-sdk/client-classic-environment-v2';

getAttack​

attacksClient.getAttack(config): Promise<Attack>

Gets the specified attack

Required scope: environment-api:attacks:read One of the following permissions is required:

  • environment:roles:manage-security-problems
  • environment:roles:view-security-problems

Parameters​

NameTypeDescription
config.fieldsstring

A list of additional attack properties you can add to the response.

The following properties are available (all other properties are always included and you can't remove them from the response):

  • attackTarget: The targeted host/database of an attack.
  • request: The request that was sent from the attacker.
  • entrypoint: The entry point used by an attacker to start a specific attack.
  • vulnerability: The vulnerability utilized by the attack.
  • securityProblem: The related security problem.
  • attacker: The attacker of an attack.
  • managementZones: The related management zones.

To add properties, specify them in a comma-separated list and prefix each property with a plus (for example, +attackTarget,+securityProblem).

config.id*requiredstringThe ID of the attack.

Returns​

Return typeStatus codeDescription
Attack200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { attacksClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await attacksClient.getAttack({ id: "..." });

getAttacks​

attacksClient.getAttacks(config): Promise<AttackList>

Lists all attacks

Required scope: environment-api:attacks:read One of the following permissions is required:

  • environment:roles:manage-security-problems
  • environment:roles:view-security-problems

Parameters​

NameTypeDescription
config.attackSelectorstring

Defines the scope of the query. Only attacks matching the specified criteria are included in the response. You can add one or more of the following criteria. Values are not case-sensitive and the EQUALS operator is used unless otherwise specified.

  • State: state("value"). The state of the attack. Possible values are EXPLOITED, BLOCKED, and ALLOWLISTED.
  • Attack Type: attackType("value"). The type of the attack. Find the possible values in the description of the attackType field of the response.
  • Country Code: countryCode("value"). The country code of the attacker. Supported values include all ISO-3166-1 alpha-2 country codes (2-letter). Supplying empty filter value countryCode() will return attacks, where location is not available.
  • Request path contains: requestPathContains("value"). Filters for a substring in the request path. The CONTAINS operator is used. A maximum of 48 characters are allowed.
  • Process group name contains: processGroupNameContains("value"). Filters for a substring in the targeted process group's name. The CONTAINS operator is used.
  • Vulnerability ID: vulnerabilityId("123456789"). The exact ID of the vulnerability.
  • Source IPs: sourceIps("93.184.216.34", "63.124.6.12"). The exact IPv4/IPv6 addresses of the attacker.
  • Management zone ID: managementZoneIds("mzId-1", "mzId-2").
  • Management zone name: managementZones("name-1", "name-2"). Values are case sensitive.
  • Technology: technology("technology-1", "technology-2"). Find the possible values in the description of the technology field of the response. The EQUALS operator is used.

To set several criteria, separate them with a comma (,). Only results matching (all criteria are included in the response.

Specify the value of a criterion as a quoted string. The following special characters must be escaped with a tilde (~) inside quotes:

  • Tilde ~
  • Quote "
config.fieldsstring

A list of additional attack properties you can add to the response.

The following properties are available (all other properties are always included and you can't remove them from the response):

  • attackTarget: The targeted host/database of an attack.
  • request: The request that was sent from the attacker.
  • entrypoint: The entry point used by an attacker to start a specific attack.
  • vulnerability: The vulnerability utilized by the attack.
  • securityProblem: The related security problem.
  • attacker: The attacker of an attack.
  • managementZones: The related management zones.
  • affectedEntities: The affected entities of an attack.

To add properties, specify them in a comma-separated list and prefix each property with a plus (for example, +attackTarget,+securityProblem).

config.fromstring

The start of the requested timeframe.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the relative timeframe of thirty days is used (now-30d).

config.nextPageKeystring

The cursor for the next page of results. You can find it in the nextPageKey field of the previous response.

The first page is always returned if you don't specify the nextPageKey query parameter.

When the nextPageKey is set to obtain subsequent pages, you must omit all other query parameters.

config.pageSizenumber

The amount of attacks in a single response payload.

The maximal allowed page size is 500.

If not set, 100 is used.

config.sortstring

Specifies one or more fields for sorting the attack list. Multiple fields can be concatenated using a comma (,) as a separator (e.g. +state,-timestamp).

You can sort by the following properties with a sign prefix for the sorting order.

  • displayId: The attack's display ID.
  • displayName: The attack's display name.
  • attackType: The type of the attack (e.g. SQL_INJECTION, JNDI_INJECTION, etc.).
  • state: The state of the attack. (+ low severity state first - high severity state first)
  • sourceIp: The IP address of the attacker. Sorts by the numerical IP value.
  • requestPath: The request path where the attack was started.
  • timestamp: When the attack was executed. (+ old attacks first or - new attacks first) If no prefix is set, + is used.
config.tostring

The end of the requested timeframe.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the current timestamp is used.

Returns​

Return typeStatus codeDescription
AttackList200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { attacksClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await attacksClient.getAttacks();

auditLogsClient​

import { auditLogsClient } from '@dynatrace-sdk/client-classic-environment-v2';

getLog​

auditLogsClient.getLog(config): Promise<AuditLogEntry>

Gets the specified entry of the audit log | maturity=EARLY_ADOPTER

Required scope: environment-api:audit-logs:read Required permission: environment:roles:manage-settings

Parameters​

NameTypeDescription
config.id*requiredstringThe ID of the required log entry.

Returns​

Return typeStatus codeDescription
AuditLogEntry200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. Invalid ID format. | Failed. The requested resource doesn't exist. | Client side error. | Server side error.

Code example

import { auditLogsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await auditLogsClient.getLog({ id: "..." });

getLogs​

auditLogsClient.getLogs(config): Promise<AuditLog>

Gets the audit log of your Dynatrace environment | maturity=EARLY_ADOPTER

Required scope: environment-api:audit-logs:read Required permission: environment:roles:manage-settings

You can limit the output by using pagination:

  1. Specify the number of results per page in the pageSize query parameter.
  2. Use the cursor from the nextPageKey field of the previous response in the nextPageKey query parameter to obtain subsequent pages.

Parameters​

NameTypeDescription
config.filterstring

Filters the audit log. You can use the following criteria:

  • User: user("userIdentification"). The EQUALS operator applies.
  • Event type: eventType("value"). The EQUALS operator applies.
  • Category of a logged operation: category("value"). The EQUALS operator applies.
  • Entity ID: entityId("id"). The CONTAINS operator applies.
  • Settings schema ID: dt.settings.schema_id("id"). The EQUALS operator applies.
  • Settings scope ID: dt.settings.scope_id("id"). The EQUALS operator applies.
  • Settings key: dt.settings.key("key"). The EQUALS operator applies.
  • Settings object ID: dt.settings.object_id("id"). The EQUALS operator applies.

For each criterion, you can specify multiple alternatives with comma-separated values. In this case, the OR logic applies. For example, eventType("CREATE","UPDATE") means eventType can be "CREATE" or "UPDATE".

You can specify multiple comma-separated criteria, such as eventType("CREATE","UPDATE"),category("CONFIG"). Only results matching all criteria are included in response.

Specify the value of a criterion as a quoted string. The following special characters must be escaped with a tilde (~) inside quotes:

  • Tilde ~
  • Quote "
config.fromstring

The start of the requested timeframe.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the relative timeframe of two weeks is used (now-2w).

config.nextPageKeystring

The cursor for the next page of results. You can find it in the nextPageKey field of the previous response.

The first page is always returned if you don't specify the nextPageKey query parameter.

When the nextPageKey is set to obtain subsequent pages, you must omit all other query parameters.

config.pageSizenumber

The amount of log entries in a single response payload.

The maximal allowed page size is 5000.

If not set, 1000 is used.

config.sortstring

The sorting of audit log entries:

  • timestamp: Oldest first.
  • -timestamp: Newest first.

If not set, the newest first sorting is applied.



Default: -timestamp
config.tostring

The end of the requested timeframe.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the current timestamp is used.

Returns​

Return typeStatus codeDescription
AuditLog200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { auditLogsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await auditLogsClient.getLogs();

businessEventsClient​

import { businessEventsClient } from '@dynatrace-sdk/client-classic-environment-v2';

ingest​

businessEventsClient.ingest(config): Promise<void>

Ingests a business event

One of the following scopes is required:

  • storage:events:write
  • openpipeline:bizevents:ingest

The maximum payload size of a single request is 5 MiB. Requests with a greater payload are rejected, and the API returns a 413 response code.

The ingestion of business events is subject to licensing (see licensing documentation).

Parameters​

NameType
config.body*requiredCloudEvent | Array<CloudEvent> | IngestBody
config.type*required"application/cloudevent+json" | "application/cloudevents+json" | "application/cloudevent-batch+json" | "application/cloudevents-batch+json" | "application/json; charset=utf-8"

Returns​

Return typeStatus codeDescription
void202The provided business events are all accepted and will be processed.

Throws​

Error TypeError Message
BizEventIngestResultErrorSome business events are invalid. Valid business events are accepted and will be processed. | Content too large | Too many requests | Service is temporarily unavailable
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { businessEventsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await businessEventsClient.ingest({
  type: "application/cloudevent+json",
  body: {
    specversion: "1.0",
    id: "1",
    source: "custom.source",
    type: "com.mycompany.shop.checkout",
    dtcontext:
      'dt.session_id="234234234324235345345",dt.entity.rum_application="APPLICATION-53453458340758",host.name="123.123.123.123"',
    dataschema:
      "http://dynatrace.com/schema/bizevents/generic/1.0",
    traceparent:
      "00-4bf92f3577b34da6a3ce929d0e0e4736-00f067aa0ba902b7-00",
    data: {
      id: "OR-838475",
      paymentType: "paypal",
      plannedDeliveryDate: "01.01.2021",
      total: 234,
    },
  },
});

credentialVaultClient​

import { credentialVaultClient } from '@dynatrace-sdk/client-classic-environment-v2';

createCredentials​

credentialVaultClient.createCredentials(config): Promise<CredentialsId>

Creates a new credentials set.

Required scope: environment-api:credentials:write Required permission: environment:roles:viewer

The body must not provide an ID. An ID is assigned automatically by the Dynatrace server.

Parameters​

NameType
config.body*requiredCredentials

Returns​

Return typeStatus codeDescription
CredentialsId201Success. The new credentials set has been created. The response contains the ID of the set.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { credentialVaultClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await credentialVaultClient.createCredentials({
  body: {
    name: "...",
    scopes: ["APP_ENGINE"],
    type: "AWS_MONITORING_KEY_BASED",
  },
});

getCredentials​

credentialVaultClient.getCredentials(config): Promise<CredentialsResponseElement>

Gets the metadata of the specified credentials set.

Required scope: environment-api:credentials:read Required permission: environment:roles:viewer

The credentials set itself (e.g. username/certificate and password) is not included in the response.

Parameters​

NameTypeDescription
config.id*requiredstringThe Dynatrace entity ID of the required credentials set.

Returns​

Return typeStatus codeDescription
CredentialsResponseElement200Success. The response contains the metadata of the credentials set.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { credentialVaultClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await credentialVaultClient.getCredentials({
  id: "...",
});

getCredentialsDetails​

credentialVaultClient.getCredentialsDetails(config): Promise<AbstractCredentialsResponseElement>

Gets the details of the specified credentials set.

Required scope: environment-api:credentials:read Required permission: environment:roles:viewer

The credentials set including username/certificate, password or token is included in the response.

Parameters​

NameTypeDescription
config.id*requiredstringThe Dynatrace entity ID of the required credentials set.

Returns​

Return typeStatus codeDescription
AbstractCredentialsResponseElement200Success. The response contains the details of the credentials set.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. E.g. Requested credentials with unsupported scope. Only APP_ENGINE scope is supported. | Failed. Requested credentials belong to another user.

Code example

import { credentialVaultClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await credentialVaultClient.getCredentialsDetails({
    id: "...",
  });

getCredentialsDetailsList​

credentialVaultClient.getCredentialsDetailsList(config): Promise<CredentialsDetailsList>

Gets the details of the specified credentials sets.

The credentials set including username/certificate, password or token is included in the response.

Parameters​

NameTypeDescription
config.idsstringThe list of Dynatrace entity IDs of the required credentials sets (separated by commas).

Returns​

Return typeStatus codeDescription
CredentialsDetailsList200Success. The response contains the details of the credentials sets.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. E.g. Requested credentials with unsupported scope. Only SYNTHETIC and APP_ENGINE scope are supported. | Failed. Requested credentials belong to another user. | Client side error. | Server side error.

Code example

import { credentialVaultClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await credentialVaultClient.getCredentialsDetailsList();

listCredentials​

credentialVaultClient.listCredentials(config): Promise<CredentialsList>

Lists all sets of credentials in your environment.

Required scope: environment-api:credentials:read Required permission: environment:roles:viewer

The credentials set itself (username/certificate and password) is not included in the response.

Parameters​

NameTypeDescription
config.namestringFilters the result by the name. When in quotation marks, whole phrase is taken. Case insensitive.
config.nextPageKeystring

The cursor for the next page of results. You can find it in the nextPageKey field of the previous response.

The first page is always returned if you don't specify the nextPageKey query parameter.

When the nextPageKey is set to obtain subsequent pages, you must omit all other query parameters.

config.pageSizenumber

The amount of credentials in a single response payload.

The maximal allowed page size is 500.

If not set, 100 is used.

config.scopestringFilters credentials with specified scope.
config.type"CERTIFICATE" | "TOKEN" | "USERNAME_PASSWORD" | "AWS_MONITORING_KEY_BASED" | "AWS_MONITORING_ROLE_BASED" | "SNMPV3"Filters the result by the specified credentials type.
config.userstringFilters credentials accessible to the user (owned by the user or the ones that are accessible for all).

Returns​

Return typeStatus codeDescription
CredentialsList200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { credentialVaultClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await credentialVaultClient.listCredentials();

removeCredentials​

credentialVaultClient.removeCredentials(config): Promise<void>

Deletes the specified credentials set

Required scope: environment-api:credentials:write Required permission: environment:roles:viewer

Provide credential ID in the path.

Parameters​

NameTypeDescription
config.id*requiredstringThe ID of the credentials set to be deleted.

Returns​

Return typeStatus codeDescription
void204Success. The credentials set has been deleted. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { credentialVaultClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await credentialVaultClient.removeCredentials({
  id: "...",
});

updateCredentials​

credentialVaultClient.updateCredentials(config): Promise<void | CredentialsId>

Updates the specified credentials set.

Required scope: environment-api:credentials:write Required permission: environment:roles:viewer

The body must not provide an ID. The ID should be provided in the path.

Parameters​

NameTypeDescription
config.body*requiredCredentials
config.id*requiredstringThe Dynatrace entity ID of the credentials set to be updated.

Returns​

Return typeStatus codeDescription
CredentialsId201Success. The new credentials set has been created. The response contains the ID of the set.
void204Success. The credentials set has been updated. Response doesn't have a body.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Client side error. | Server side error.

Code example

import { credentialVaultClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await credentialVaultClient.updateCredentials({
  id: "...",
  body: {
    name: "...",
    scopes: ["APP_ENGINE"],
    type: "AWS_MONITORING_KEY_BASED",
  },
});

davisSecurityAdvisorClient​

import { davisSecurityAdvisorClient } from '@dynatrace-sdk/client-classic-environment-v2';

getAdviceForSecurityProblems​

davisSecurityAdvisorClient.getAdviceForSecurityProblems(config): Promise<DavisSecurityAdviceList>

Provides advice for security problems.

Required scope: environment-api:security-problems:read One of the following permissions is required:

  • environment:roles:manage-security-problems
  • environment:roles:view-security-problems

You can narrow down the output by providing the management zone and pagination. If you specify a management zone, only problems originating from that zone are included to the request.

Parameters​

NameTypeDescription
config.managementZoneFilterstring

To specify management zones, use one of the options listed below. For each option you can specify multiple comma-separated values. If several values are specified, the OR logic applies. All values are case-sensitive and must be quoted.

  • Management zone ID: ids("mzId-1", "mzId-2").
  • Management zone names: names("mz-1", "mz-2").

You can specify several comma-separated criteria (for example, names("myMz"),ids("9130632296508575249")).

config.nextPageKeystring

The cursor for the next page of results. You can find it in the nextPageKey field of the previous response.

The first page is always returned if you don't specify the nextPageKey query parameter.

When the nextPageKey is set to obtain subsequent pages, you must omit all other query parameters.

config.pageSizenumber

The amount of security advices in a single response payload.

The maximal allowed page size is 500.

If not set, 5 is used.

Returns​

Return typeStatus codeDescription
DavisSecurityAdviceList200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { davisSecurityAdvisorClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await davisSecurityAdvisorClient.getAdviceForSecurityProblems();

eventsClient​

import { eventsClient } from '@dynatrace-sdk/client-classic-environment-v2';

createEvent​

eventsClient.createEvent(config): Promise<EventIngestResults>

Ingests a custom event

One of the following scopes is required:

  • openpipeline:events.davis:ingest
  • storage:events:write
  • environment-api:events:write

One of the following permissions is required:

  • environment:roles:viewer
  • openpipeline:events.davis:ingest

The ingestion of custom events is subject to licensing (see licensing documentation).

Parameters​

NameType
config.body*requiredEventIngest

Returns​

Return typeStatus codeDescription
EventIngestResults201The event ingest request was received by the server. The response body indicates for each event whether its creation was successful.

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { eventsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await eventsClient.createEvent({
  body: { eventType: "AVAILABILITY_EVENT", title: "..." },
});

getEvent​

eventsClient.getEvent(config): Promise<Event>

Gets the properties of an event

Required scope: environment-api:events:read Required permission: environment:roles:viewer

Parameters​

NameTypeDescription
config.eventId*requiredstringThe ID of the required event.

Returns​

Return typeStatus codeDescription
Event200Success. The response contains the configuration of the event.

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { eventsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await eventsClient.getEvent({
  eventId: "...",
});

getEventProperties​

eventsClient.getEventProperties(config): Promise<EventPropertiesList>

Lists all event properties

One of the following scopes is required:

  • storage:events:read
  • environment-api:events:read

One of the following permissions is required:

  • environment:roles:viewer
  • storage:events:read

Parameters​

NameTypeDescription
config.nextPageKeystring

The cursor for the next page of results. You can find it in the nextPageKey field of the previous response.

The first page is always returned if you don't specify the nextPageKey query parameter.

When the nextPageKey is set to obtain subsequent pages, you must omit all other query parameters.

config.pageSizenumber

The amount of event properties in a single response payload.

The maximal allowed page size is 500.

If not set, 100 is used.

Returns​

Return typeStatus codeDescription
EventPropertiesList200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { eventsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await eventsClient.getEventProperties();

getEventProperty​

eventsClient.getEventProperty(config): Promise<EventPropertyDetails>

Gets the details of an event property

One of the following scopes is required:

  • storage:events:read
  • environment-api:events:read

One of the following permissions is required:

  • environment:roles:viewer
  • storage:events:read

Parameters​

NameTypeDescription
config.propertyKey*requiredstringThe event property key you're inquiring.

Returns​

Return typeStatus codeDescription
EventPropertyDetails200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { eventsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await eventsClient.getEventProperty({
  propertyKey: "...",
});

getEventType​

eventsClient.getEventType(config): Promise<EventType>

Gets the properties of an event type

One of the following scopes is required:

  • storage:events:read
  • environment-api:events:read

One of the following permissions is required:

  • environment:roles:viewer
  • storage:events:read

Parameters​

NameTypeDescription
config.eventType*requiredstringThe event type you're inquiring.

Returns​

Return typeStatus codeDescription
EventType200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { eventsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await eventsClient.getEventType({
  eventType: "...",
});

getEventTypes​

eventsClient.getEventTypes(config): Promise<EventTypeList>

Lists all event types

One of the following scopes is required:

  • storage:events:read
  • environment-api:events:read

One of the following permissions is required:

  • environment:roles:viewer
  • storage:events:read

Parameters​

NameTypeDescription
config.nextPageKeystring

The cursor for the next page of results. You can find it in the nextPageKey field of the previous response.

The first page is always returned if you don't specify the nextPageKey query parameter.

When the nextPageKey is set to obtain subsequent pages, you must omit all other query parameters.

config.pageSizenumber

The amount of event types in a single response payload.

The maximal allowed page size is 500.

If not set, 100 is used.

Returns​

Return typeStatus codeDescription
EventTypeList200Success

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { eventsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await eventsClient.getEventTypes();

getEvents​

eventsClient.getEvents(config): Promise<EventList>

Lists events within the specified timeframe

Required scope: environment-api:events:read Required permission: environment:roles:viewer

Parameters​

NameTypeDescription
config.entitySelectorstring

The entity scope of the query. You must set one of these criteria:

  • Entity type: type("TYPE")
  • Dynatrace entity ID: entityId("id"). You can specify several IDs, separated by a comma (entityId("id-1","id-2")). All requested entities must be of the same type.

You can add one or more of the following criteria. Values are case-sensitive and the EQUALS operator is used unless otherwise specified.

  • Tag: tag("value"). Tags in [context]key:value, key:value, and value formats are detected and parsed automatically. Any colons (:) that are part of the key or value must be escaped with a backslash(\). Otherwise, it will be interpreted as the separator between the key and the value. All tag values are case-sensitive.
  • Management zone ID: mzId(123)
  • Management zone name: mzName("value")
  • Entity name:
    • entityName.equals: performs a non-casesensitive EQUALS query.
    • entityName.startsWith: changes the operator to BEGINS WITH.
    • entityName.in: enables you to provide multiple values. The EQUALS operator applies.
    • caseSensitive(entityName.equals("value")): takes any entity name criterion as an argument and makes the value case-sensitive.
  • Health state (HEALTHY,UNHEALTHY): healthState("HEALTHY")
  • First seen timestamp: firstSeenTms.<operator>(now-3h). Use any timestamp format from the from /to parameters. The following operators are available:
    • lte: earlier than or at the specified time
    • lt: earlier than the specified time
    • gte: later than or at the specified time
    • gt: later than the specified time
  • Entity attribute: <attribute>("value1","value2") and <attribute>.exists(). To fetch the list of available attributes, execute the GET entity type request and check the properties field of the response.
  • Relationships: fromRelationships.<relationshipName>() and toRelationships.<relationshipName>(). This criterion takes an entity selector as an attribute. To fetch the list of available relationships, execute the GET entity type request and check the fromRelationships and toRelationships fields.
  • Negation: not(<criterion>). Inverts any criterion except for type.

For more information, see Entity selector in Dynatrace Documentation.

To set several criteria, separate them with a comma (,). For example, type("HOST"),healthState("HEALTHY"). Only results matching all criteria are included in the response.

The maximum string length is 2,000 characters.

The number of entities that can be selected is limited to 10000.

config.eventSelectorstring

Defines the scope of the query. Only events matching the specified criteria are included in the response.

You can add one or several of the criteria listed below. For each criterion you can specify multiple comma-separated values, unless stated otherwise. If several values are specified, the OR logic applies.

  • Event ID: eventId("id-1", "id-2").
  • ID of related entity: entityId("id-1", "id-2").
  • Event status: status("OPEN") or status("CLOSED"). You can specify only one status.
  • Management zone ID: managementZoneId("123", "321").
  • Event type: eventType("event-type"). You can specify only one event type. You can fetch the list of possible event types with the GET event types call.
  • Correlation ID: correlationId("id-1", "id-2").
  • Happened during maintenance (true, false): underMaintenance(true).
  • Notifications are suppressed (true, false): suppressAlert(true).
  • Problem creation is suppressed (true, false): suppressProblem(true).
  • Frequent event (true, false): frequentEvent(true).
  • Event property: property.<key>("value-1", "value-2"). Only properties with the filterable property set to true can be used. You can check event properties via the GET event properties call.

To set several criteria, separate them with commas (,). Only results matching all criteria are included in the response.

config.fromstring

The start of the requested timeframe.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the relative timeframe of two hours is used (now-2h).

config.nextPageKeystring

The cursor for the next page of results. You can find it in the nextPageKey field of the previous response.

The first page is always returned if you don't specify the nextPageKey query parameter.

When the nextPageKey is set to obtain subsequent pages, you must omit all other query parameters.

config.pageSizenumber

The amount of events in a single response payload.

The maximal allowed page size is 1000.

If not set, 100 is used.

config.tostring

The end of the requested timeframe.

You can use one of the following formats:

  • Timestamp in UTC milliseconds.
  • Human-readable format of 2021-01-25T05:57:01.123+01:00. If no time zone is specified, UTC is used. You can use a space character instead of the T. Seconds and fractions of a second are optional.
  • Relative timeframe, back from now. The format is now-NU/A, where N is the amount of time, U is the unit of time, and A is an alignment. The alignment rounds all the smaller values to the nearest zero in the past. For example, now-1y/w is one year back, aligned by a week. You can also specify relative timeframe without an alignment: now-NU. Supported time units for the relative timeframe are:
    • m: minutes
    • h: hours
    • d: days
    • w: weeks
    • M: months
    • y: years

If not set, the current timestamp is used.

Returns​

Return typeStatus codeDescription
EventList200Success. The response contains the list of events.

Throws​

Error TypeError Message
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { eventsClient } from "@dynatrace-sdk/client-classic-environment-v2";

const data = await eventsClient.getEvents();

extensions_2_0Client​

import { extensions_2_0Client } from '@dynatrace-sdk/client-classic-environment-v2';

activateExtensionEnvironmentConfiguration​

⚠️ Deprecated

extensions_2_0Client.activateExtensionEnvironmentConfiguration(config): Promise<ExtensionEnvironmentConfigurationVersion>

Activates the environment configuration from the specified version of the extension 2.0

Required scope: environment-api:extensions:write One of the following permissions is required:

  • environment:roles:manage-settings
  • extensions:definitions:write

Deprecated since version 1.342. Use the successor API /platform/extensions/v2 instead.

Parameters​

NameTypeDescription
config.body*requiredExtensionEnvironmentConfigurationVersion
config.extensionName*requiredstringThe name of the requested extension 2.0.

Returns​

Return typeStatus codeDescription
ExtensionEnvironmentConfigurationVersion200Success. Environment configuration created. If the requested version was already active, this is an idempotent no-op (no backend state changes).

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The input is invalid. | Failed. The requested resource doesn't exist. | Client side error. | Server side error.

Code example

import { extensions_2_0Client } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await extensions_2_0Client.activateExtensionEnvironmentConfiguration(
    { extensionName: "...", body: { version: "1.2.3" } },
  );

createMonitoringConfiguration​

extensions_2_0Client.createMonitoringConfiguration(config): Promise<Array<MonitoringConfigurationResponse>>

Creates new monitoring configuration for the specified extension 2.0

Required scope: environment-api:extension-configurations:write One of the following permissions is required:

  • environment:roles:manage-settings
  • extensions:configurations:write

Deprecated since version 1.342. Use the successor API /platform/extensions/v2 instead.

Parameters​

NameTypeDescription
config.body*requiredArray<MonitoringConfigurationDto>
config.extensionName*requiredstringThe name of the requested extension 2.0.

Returns​

Return typeStatus codeDescription
MonitoringConfigurationResponse200Success
ErrorEnvelope207Multi-Status, if not all requests resulted in the same status

Throws​

Error TypeError Message
ErrorEnvelopeArrayErrorFailed. The input is invalid. | Failed. The requested resource doesn't exist.
ErrorEnvelopeErrorClient side error. | Server side error.

Code example

import { extensions_2_0Client } from "@dynatrace-sdk/client-classic-environment-v2";

const data =
  await extensions_2_0Client.createMonitoringConfiguration({
    extensionName: "...",
    body: [{ scope: "HOST-D3A3C5A146830A79" }],
  });
extensions_2_0Client.createMonitoringConfiguration(config): Promise<Array<ErrorEnvelope | MonitoringConfigurationResponse>>

Parameters​

NameTypeDescription
config.body*requiredArray<MonitoringConfigurationDto>
config.extensionName*requiredstringThe name of the requested extension 2.0.

Returns​

Return typeStatus codeDescription
MonitoringConfigurationResponse200Success
ErrorEnvelope207Multi-Status, if not all requests resulted in the same status

deleteEnvironmentConfiguration​

⚠️ Deprecated

extensions_2_0Client.deleteEnvironmentConfiguration(config): Promise<ExtensionEnvironmentConfigurationVersion>

Deactivates the environment configuration of the specified extension 2.0

Required scope: environment-api:extensions:write One of the following permissions is required:

  • environment:roles:manage-settings
  • extensions:definitions:write

Deprecated since version 1.342. Use the successor API /platform/extensions/v2 instead.

Parameters​

NameTypeDescription
config.extensionName*requiredstringThe name of the requested extension 2.0.

Returns​

Return typeStatus codeDescription
ExtensionEnvironmentConfigurationVersion200Success. Environment configuration deactivated.

Throws​

Error TypeError Message
ErrorEnvelopeErrorFailed. The requested resource doesn't exist. | Client side error. | Server side error.

Code example

[...]
